var iterations : int = 8;
var lineWidth : float = 0.5;
var flameLength : float = 20.0;
var tipSpeed : float = 1.0;
var spurtSpeed : float = 5.0;

private var flameMesh : Mesh;

function Start(){
	var counter : int;
	flameMesh = new Mesh();
	GetComponent(MeshFilter).mesh = flameMesh;
	var newVerts : Vector3[] = new Vector3[iterations * 2];
	var newUVs : Vector2[] = new Vector2[iterations * 2]; //this mesh is used for particles rather than actual rendering --nothing fancy with the UVs
	var newTris : int[] = new int[(iterations - 1) * 6];
	
	//setup verts
	for(counter = 0; counter < iterations; counter++){
		var calcCnt : float = counter;
		var calcIt : float = iterations;
		newVerts[counter] = Vector3(-lineWidth, 0, calcCnt / calcIt * flameLength);
		newVerts[counter + (iterations)] = Vector3(lineWidth, 0, calcCnt / calcIt * flameLength);
	}
	
	//setup triangles
	for(counter = 0; counter < ((iterations - 1) * 2); counter++){
		var triIndex : int = counter * 3;
		var wrapped : int = WrapInt(counter, iterations - 1);
		var diff : int = (counter - wrapped) / (iterations - 1);
		newTris[triIndex + (diff * 2)] = wrapped + diff;
		newTris[triIndex + 1] = wrapped + 1 + (diff * (iterations - 1));
		newTris[triIndex + 2 - (diff * 2)] = wrapped + iterations + diff;
	}
	
	//setup Uvs -- this mesh is for particles not rendering, so nothing fancy
	for (counter = 0; counter < newUVs.Length; counter++) newUVs[counter] = Vector2 (newVerts[counter].x, newVerts[counter].z);

	flameMesh.vertices = newVerts;
	flameMesh.uv = newUVs;
	flameMesh.triangles = newTris;
	flameMesh.RecalculateNormals();
	
	//particleEmitter.mesh = flameMesh;
}

function Update(){
	var vertIndex : int = 0;
	var newVerts = flameMesh.vertices;
	for(var vert in newVerts){
		Debug.DrawRay(vert, transform.up * 5, Color.green);
		
		//curl it with mosue input
		particleEmitter.emit = (Input.GetMouseButton(0));
		var zMult : float = (Input.GetMouseButton(0) ? 1 : 0);
		var cvi : float = WrapInt(vertIndex, iterations);
		var ci : float = iterations;
		vert.z = Mathf.Lerp(vert.z, /*(cvi / ci) * zMult * flameLength*/ flameLength * (1 - (Mathf.Pow(0.8, cvi))) * zMult, Time.deltaTime * spurtSpeed);
		vert.x -= Input.GetAxis("Mouse X") * 0.02 * tipSpeed;
		vert.y -= Input.GetAxis("Mouse Y") * 0.02 * tipSpeed;
		var lineWidthMult : float = -1.0;
		if(vertIndex == iterations){
			lineWidthMult = 1.0;
		}
		vert.x = Mathf.Lerp(vert.x, 0, Time.deltaTime * (tipSpeed / vert.z));
		vert.y = Mathf.Lerp(vert.y, 0, Time.deltaTime * (tipSpeed / vert.z));
		vertIndex++;
	}
	flameMesh.vertices = newVerts;
}

function WrapInt(theInt : int, maxValue : int) : int{
	if(theInt >= maxValue) return theInt - maxValue;
	return theInt;
}

/*
counter = 0
verts = 0 1 7
counter = 1
verts = 1 2 8
*/